; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 656
WINDOWHEIGHT = 518
MAX_PARTICLES equ 1000
float = dword

BITMAPFILEHEADER STRUCT
  bfType        dw ?
  bfSize        dd ?
  bfReserved1   dw ?
  bfReserved2   dw ?
  bfOffBits     dd ?
BITMAPFILEHEADER ENDS
BITMAPINFOHEADER STRUCT
  biSize          dd ?
  biWidth         dd ?
  biHeight        dd ?
  biPlanes        dw ?
  biBitCount      dw ?
  biCompression   dd ?
  biSizeImage     dd ?
  biXPelsPerMeter dd ?
  biYPelsPerMeter dd ?
  biClrUsed       dd ?
  biClrImportant  dd ?
BITMAPINFOHEADER ENDS
TEXTURE_IMAGE struct
  sizeX		dd ?; Width Of Image In Pixels
  sizeY		dd ?; Height Of Image In Pixels
  data_		dd ?; Texture Data
TEXTURE_IMAGE ends
;File header
MS3DHeader struct 
	m_ID		db 10 dup (?)
	m_version	dd ?
MS3DHeader ends;+0Eh
;Vertex information
MS3DVertex struct 
	m_flags		db ?
	m_vertex	dd 3 dup(?);+1
	m_boneID	db ?;+0Dh
	m_refCount	db ?;+0Eh
MS3DVertex ends;+0Fh=sizeof MS3DVertex
;Vertex structure
Vertex struct
	m_boneID	db ?; for skeletal animation
	m_location	dd 3 dup(?);+1
Vertex ends;+0Dh
;Triangle information
MS3DTriangle struct 
	m_flags		dw ?
	m_vertexIndices dw 3 dup(?);+2
	m_vertexNormals dd 9 dup(?);+8
	m_s		dd 3 dup(?);+2Ch
	m_t		dd 3 dup(?);+38h
	m_smoothingGroup db ?      ;+44h
	m_groupIndex	db ?       ;+45h
MS3DTriangle ends                  ;+46h
Triangle struct 
	m_vertexNormals dd 9 dup(?);+0
	m_s		dd 3 dup(?);+24h
	m_t		dd 3 dup(?);+30h
	m_vertexIndices dd 3 dup(?);+3Ch
Triangle ends;+48h
;Material information
MS3DMaterial struct 
	m_name		db 32 dup(?);+0
	m_ambient	dd 4 dup(?) ;+20h
	m_diffuse	dd 4 dup(?) ;+30h
	m_specular	dd 4 dup(?) ;+40h
	m_emissive	dd 4 dup(?) ;+50h
	m_shininess	dd ?;0 - 128.0;+60h
	m_transparency	dd ?;0 - 1.0;+64h
	m_mode		db ?;0, 1, 2 is unused now;+68h
	m_texture	db 128 dup(?);+69h
	m_alphamap	db 128 dup(?);+0E9h
MS3DMaterial ends;+169h

Mesh STRUCT
	m_materialIndex dd ?	;+0
	m_numTriangles	dd ?	;+8
	m_pTriangleIndices dd ?	;+10h
Mesh ENDS			;+14h
;Material properties
Material struct
	m_ambient	dd 4 dup(?)	;+0 
	m_diffuse	dd 4 dup(?)	;+10h
	m_specular	dd 4 dup(?)	;+20h
	m_emissive	dd 4 dup(?)	;+30h
	m_shininess	dd ?		;+40h
	m_texture	dd ?		;+44h
	m_pTextureFilename	dd ?	;+48h
Material ends;+4Ch
Model_ STRUCT
	dd ?
; 
	m_numMeshes	dd ?;+4
	m_pMeshes	dq ?;+8
; 
	m_numMaterials	dd ?;+0Ch
	m_pMaterials	dq ?;+10h
; 
	m_numTriangles	dd ?;+14h
	m_pTriangles	dq ?;+18h 
;  
	m_numVertices	dd ?;+1Ch
	m_pVertices	dq ?;+20h
Model_ ENDS                 ;+24h

.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	w:dword
local	h:dword
local	ps:PAINTSTRUCT

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_TIMER
	je      wmTIMER
        cmp	edx,WM_DESTROY
	je      wmDESTROY
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	invoke	KillTimer,hWin,10
	invoke	HeapFree,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,pModel
	invoke	HeapFree,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,Mem1
	invoke	HeapFree,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,Mem2
	invoke	HeapFree,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,Mem3
	invoke	HeapFree,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,Mem4
	invoke	HeapFree,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,Mem5
;	invoke	HeapFree,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,Mem6
	invoke	RtlExitUserProcess,NULL
;----------------------------------------------
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmTIMER:movss	xmm0,yrot
	addss	xmm0,const1;	Increase yrot By One
	movss	yrot,xmm0
	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,12,0
;-------------------------------------------------------
;InitGL(GLvoid)	// All Setup For OpenGL Goes Here
        invoke	HeapCreate,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,4000000h,0;4000000h
;        invoke	GetProcessHeap
	mov	hHeap,rax
	
	invoke	RtlAllocateHeap,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,sizeof Model_
	mov	pModel,rax;pModel = new MilkshapeModel(); Memory To Hold The Model
	mov	edx,offset FileName2
	invoke	loadModelData,eax;pModel->loadModelData("data/model.ms3d") ;Loads The Model And Checks For Errors
	invoke	reloadTextures,pModel;	pModel->reloadTextures(); Loads Model Textures
	invoke	glEnable,GL_TEXTURE_2D; Enable Texture Mapping ( NEW )
	invoke	glShadeModel,GL_SMOOTH; Enable Smooth Shading
        movss	xmm3, const0_5
	xorps	xmm2, xmm2
	xorps	xmm1, xmm1
	xorps	xmm0, xmm0
	invoke	glClearColor; Black Background
        movsd	xmm0, constd1
	invoke	glClearDepth; Depth Buffer Setup
	invoke	glEnable,GL_DEPTH_TEST; Enables Depth Testing
	invoke	glDepthFunc,GL_LEQUAL; The Type Of Depth Testing To Do
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST; Really Nice Perspective Calculations	
	mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd1000
	movq	xmm2,constd1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
; --------------- Display the scene
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT; Clear The Screen And The Depth Buffer
	invoke	glLoadIdentity; Reset The Modelview Matrix
	xorps	xmm3, xmm3
	movsd	qword ptr [rsp+40h],xmm3
	mov	rax, constd1
	mov	qword ptr [rsp+38h],rax
	movsd	qword ptr [rsp+30h],xmm3
	movsd	qword ptr [rsp+28h],xmm3
	movsd	qword ptr [rsp+20h],xmm3
	movsd	xmm2, constd75
	movsd	xmm1,xmm2
	movsd	xmm0,xmm2
	invoke	gluLookAt;75, 75, 75, 0, 0, 0, 0, 1, 0 ); (3) Eye Postion (3) Center Point (3) Y-Axis Up Vector
        xorps	xmm3, xmm3
	movss	xmm2, const1
	xorps	xmm1, xmm1
	movss	xmm0, yrot
	invoke	glRotatef;yrot,0,1,0	Rotate On The Y-Axis By yrot
	invoke	draw,pModel; Draw The Model
;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke	EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
loadModelData proc MilkshapeModel:dword,filename:dword
local	FSize:dword
local	szReadWrite:QWORD	;number of bytes actually read or write
local	hFile:dword
local	pPtr:dword
local	nVertices:dword
local	m_pVertices:dword
local	old_edi:dword
local	old_esi:dword
local	pVertex:dword
local	vertexIndices[3]:dword
local	t[3]:dword
local	pTriangle:dword
local	nTriangles:dword
local	nGroups:dword
local	pTriangleIndices:dword
local	materialIndex:byte
local	nMaterials:dword
local	pMaterial:dword
local	temp:dword
local	pBuffer:qword
local	buff[20]:dword

	mov	old_edi,edi
	mov	old_esi,esi
	mov	esi,ecx;MilkshapeModel,ecx
        mov	ecx,edx;offset FileName2
;	ifstream inputFile( filename, ios::in | ios::binary | ios::nocreate );
	xor	r8d,r8d
	mov	[rsp+30h],r8
	mov	qword ptr [rsp+28h],FILE_ATTRIBUTE_ARCHIVE
	mov	qword ptr [rsp+20h],OPEN_EXISTING
	invoke	CreateFile,,GENERIC_READ or GENERIC_WRITE,,0
        mov	hFile,eax
        invoke	GetFileSize,eax,0;inputFile.seekg( 0, ios::end );
        mov	FSize,eax;	long fileSize = inputFile.tellg();
;	inputFile.seekg( 0, ios::beg );
        invoke	RtlAllocateHeap,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax
	mov	pBuffer,rax;	byte *pBuffer = new byte[fileSize];
	mov	pPtr,eax
        and	qword ptr [rsp+20h],0
	lea	r9d,szReadWrite
        invoke	ReadFile,hFile,eax,FSize;	inputFile.read( pBuffer, fileSize );
        invoke	CloseHandle,hFile;	inputFile.close();

;	const byte *pPtr = pBuffer;
;	MS3DHeader *pHeader = ( MS3DHeader* )pPtr;
	add	pPtr,sizeof MS3DHeader;	pPtr += sizeof( MS3DHeader );

;	if ( strncmp( pHeader->m_ID, "MS3D000000", 10 ) != 0 )
	push	rsi
        mov	rdi,pBuffer
	mov	esi,offset Str2
	mov	ecx,10
	repe	cmpsb
	pop	rsi
        or	ecx,ecx
	jnz	exit0
;	if ( pHeader->m_version < 3 || pHeader->m_version > 4 )
;		return false; // "Unhandled file version. Only Milkshape3D Version 1.3 and 1.4 is supported." );
;        mov	rcx,pBuffer
	cmp	byte ptr [rdi],3;.MS3DHeader.m_version,3
        jb	exit0
	cmp	byte ptr [rdi],4;.MS3DHeader.m_version,4
        ja	exit0
;	int nVertices = *( word* )pPtr; 
	movzx	eax, word ptr [rdi+4]
	mov	nVertices, eax
	mov	[rsi].Model_.m_numVertices,eax;	m_numVertices = nVertices;
        imul	r8d,eax,sizeof Vertex
	mov	temp,r8d
	invoke	RtlAllocateHeap,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY
	mov	Mem1,rax
	mov	[rsi].Model_.m_pVertices,rax;	m_pVertices = new Vertex[nVertices];
        add	pPtr,sizeof word;	pPtr += sizeof( word );
;     .       , 
;    ,      .    
;  memcpy     .  m_boneID 
; -    
	xor	edi,edi;i=0
@@:     mov	eax,pPtr
        mov	dl, byte ptr [rax].MS3DVertex.m_boneID;[rdx+0Dh]
	mov	rcx,[rsi].Model_.m_pVertices
        mov	[rcx+rdi].Vertex.m_boneID,dl;m_pVertices[i].m_boneID = pVertex->m_boneID
        mov	r8d,(sizeof float)*3
        lea	edx,[rax].MS3DVertex.m_vertex
        lea	ecx,[rcx+rdi].Vertex.m_location
        invoke	memcpy
        add	pPtr,sizeof MS3DVertex
        add	edi,sizeof Vertex
	cmp	edi,temp
	jb	@b
;	int i;
;	for ( i = 0; i < nVertices; i++ )
;	{
;		MS3DVertex *pVertex = ( MS3DVertex* )pPtr;
;		m_pVertices[i].m_boneID = pVertex->m_boneID;
;		memcpy( m_pVertices[i].m_location, pVertex->m_vertex, sizeof( float )*3 );
;		pPtr += sizeof( MS3DVertex );
;	}
        mov	eax, pPtr
	movzx	edx, word ptr [rax]
	mov	nTriangles,edx;	int nTriangles = *( word* )pPtr;
	mov	[rsi].Model_.m_numTriangles,edx;m_numTriangles = nTriangles;
        imul	r8d,edx,sizeof Triangle
        invoke	RtlAllocateHeap,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY
	mov	Mem2,rax;	m_pTriangles = new Triangle[nTriangles];
        imul	edx,nTriangles,sizeof Triangle
        mov	temp,edx
	mov	[rsi].Model_.m_pTriangles,rax
        add	pPtr,sizeof word;	pPtr += sizeof( word );
;      .       
;,    vertexIndeces  t-.       
;   word,      dword    . 
; 3    int.   t    1.0 - ( ). OpenGL 
;    , Milkshape     
	xor	edi,edi
@@:	mov	ecx, pPtr
	mov	pTriangle,ecx
	movzx	eax, word ptr [rcx+2*0].MS3DTriangle.m_vertexIndices
	mov	vertexIndices[0*4], eax;pTriangle->m_vertexIndices[0*4]
	movzx	eax, word ptr [rcx+2*1].MS3DTriangle.m_vertexIndices
	mov	vertexIndices[1*4], eax;pTriangle->m_vertexIndices[1*4]
	movzx	eax, word ptr [rcx+2*2].MS3DTriangle.m_vertexIndices
	mov	vertexIndices[2*4], eax;pTriangle->m_vertexIndices[2*4]
	movss	xmm0, const1
	movss	xmm1,xmm0
	movss	xmm2,xmm0
	subss	xmm0, dword ptr	[rcx+4*0].MS3DTriangle.m_t
	movss	t[0*4],xmm0;t[0*4]=1.0 - pTriangle->m_t[0]
	subss	xmm1, dword ptr	[rcx+4*1].MS3DTriangle.m_t
	movss	t[1*4],xmm1;t[1*4]=1.0 - pTriangle->m_t[1*4]
	subss	xmm2, dword ptr	[rcx+4*2].MS3DTriangle.m_t
	movss	t[2*4],xmm2;t[2*4]=1.0 - pTriangle->m_t[2*4]
;	for ( i = 0; i < nTriangles; i++ )
;	{
;		MS3DTriangle *pTriangle = ( MS3DTriangle* )pPtr;
;		int vertexIndices[3] = { pTriangle->m_vertexIndices[0], pTriangle->m_vertexIndices[1], pTriangle->m_vertexIndices[2] };
;		float t[3] = { 1.0f-pTriangle->m_t[0], 1.0f-pTriangle->m_t[1], 1.0f-pTriangle->m_t[2] };
	mov	r8d,(sizeof float)*3*3
        mov	eax, pTriangle
	lea	edx,[rax].MS3DTriangle.m_vertexNormals;8;pTriangle->m_vertexNormals
	mov	rax,[rsi].Model_.m_pTriangles
	lea	ecx,[rdi+rax].Triangle.m_vertexNormals;m_pTriangles[i].m_vertexNormals
        invoke	memcpy;memcpy(m_pTriangles[i].m_vertexNormals,pTriangle->m_vertexNormals,sizeof(float )*3*3);
	mov	r8d,(sizeof float)*3
        mov	eax, pTriangle
	lea	edx,[rax].MS3DTriangle.m_s
	mov	rax,[rsi].Model_.m_pTriangles
	lea	ecx,[rdi+rax].Triangle.m_s
        invoke	memcpy;memcpy( m_pTriangles[i].m_s, pTriangle->m_s, sizeof( float )*3 );
	mov	r8d,(sizeof float)*3
        lea	edx,t
	mov	rax,[rsi].Model_.m_pTriangles
	lea	ecx,[rdi+rax].Triangle.m_t
        invoke	memcpy;memcpy( m_pTriangles[i].m_t, t, sizeof( float )*3 );
	mov	r8d,(sizeof dword)*3
        lea	edx,vertexIndices
	mov	rax,[rsi].Model_.m_pTriangles
	lea	ecx,[rdi+rax].Triangle.m_vertexIndices
        invoke	memcpy;memcpy( m_pTriangles[i].m_vertexIndices, vertexIndices, sizeof( int )*3 );
        add	pPtr,sizeof MS3DTriangle;pPtr += sizeof( MS3DTriangle );
	add	edi,sizeof Triangle
	cmp	edi,temp
	jb	@b
;    ( Milkshape3D -- "groups").     
;  ,     .    .   
;         .
        mov	eax, pPtr
	movzx	eax, word ptr [rax]
	mov	nGroups, eax;	int nGroups = *( word* )pPtr;
	mov	[rsi].Model_.m_numMeshes,eax;	m_numMeshes = nGroups;
	imul	r8d,eax,sizeof Mesh
        mov	temp,r8d
	invoke	RtlAllocateHeap,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY
	mov	Mem3,rax
	mov	[rsi].Model_.m_pMeshes,rax ;	m_pMeshes = new Mesh[nGroups];
        add	pPtr,sizeof word;	pPtr += sizeof( word );
	xor	edi,edi;i=0
;---------------------------------------
@1:	add	pPtr,33
;	for ( i = 0; i < nGroups; i++ )
;	{
;		pPtr += sizeof( byte );	// flags
;		pPtr += 32;				// name
        mov	eax, pPtr
	movzx	eax, word ptr [rax]
	mov	nTriangles,eax;	word nTriangles = *( word* )pPtr;
        add	pPtr,sizeof word;		pPtr += sizeof( word );
        imul	r8d,eax,sizeof dword;nTriangles*int
	invoke	RtlAllocateHeap,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY
	mov	Mem4,rax
	mov	pTriangleIndices,eax;int *pTriangleIndices = new int[nTriangles];
	xor	ecx,ecx
	mov	edx,pTriangleIndices
;---------------------------------------
@@:	mov	eax,pPtr
	movzx	eax,word ptr [rax]
	mov	[rdx+rcx*4],eax;pTriangleIndices[j] = *( word* )pPtr
	add	pPtr,sizeof word
        inc	ecx;j
	cmp	ecx,nTriangles
	jb	@b
;		for ( int j = 0; j < nTriangles; j++ )
;		{
;			pTriangleIndices[j] = *( word* )pPtr;
;			pPtr += sizeof( word );
;		}
;   .        . 
;     ,  ,      . 
        mov	eax, pPtr
	movzx	eax, byte ptr [rax]
	mov	materialIndex, al
;		char materialIndex = *( char* )pPtr;
        inc	pPtr;		pPtr += sizeof( char );
	mov	rcx,[rsi].Model_.m_pMeshes
	mov	[rcx+rdi].Mesh.m_materialIndex,eax;m_pMeshes[i].m_materialIndex = materialIndex;
        mov	eax,nTriangles
	mov	[rcx+rdi].Mesh.m_numTriangles,eax;m_pMeshes[i].m_numTriangles = nTriangles;
        mov	eax, pTriangleIndices
	mov	[rcx+rdi].Mesh.m_pTriangleIndices,eax;m_pMeshes[i].m_pTriangleIndices = pTriangleIndices;
        add	edi,sizeof Mesh
        cmp	edi,temp; nGroups
	jb	@1
;	}
        mov	eax, pPtr
	movzx	eax, word ptr [rax]
	mov	nMaterials, eax;	int nMaterials = *( word* )pPtr;
	mov	[rsi].Model_.m_numMaterials,eax;	m_numMaterials = nMaterials;
        imul	r8d,eax,sizeof Material
        mov	temp,r8d
	invoke	RtlAllocateHeap,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY
	mov	Mem5,rax
	mov	[rsi].Model_.m_pMaterials,rax;	m_pMaterials = new Material[nMaterials];
        add	pPtr,sizeof word;	pPtr += sizeof( word );
	imul	eax,nMaterials,sizeof Material
	mov	temp,eax
	xor	edi,edi
;	for ( i = 0; i < nMaterials; i++ )
@@:
	mov	ecx,pPtr
	mov	pMaterial,ecx;	MS3DMaterial *pMaterial = ( MS3DMaterial* )pPtr;
	mov	r8d,(sizeof float)*4
	lea	edx,[rcx].MS3DMaterial.m_ambient
	mov	rcx,[rsi].Model_.m_pMaterials
	lea	ecx,[rcx+rdi].Material.m_ambient
	invoke	memcpy;memcpy(m_pMaterials[i].m_ambient,pMaterial->m_ambient,sizeof(float)*4);
	mov	r8d,(sizeof float)*4
	mov	ecx,pMaterial
	lea	edx,[rcx].MS3DMaterial.m_ambient
	mov	rcx,[rsi].Model_.m_pMaterials
	lea	ecx,[rcx+rdi].Material.m_diffuse
	invoke	memcpy;memcpy(m_pMaterials[i].m_diffuse,pMaterial->m_diffuse,sizeof(float)*4 );
	mov	r8d,(sizeof float)*4
	mov	ecx,pMaterial
	lea	edx,[rcx].MS3DMaterial.m_specular
	mov	rcx,[rsi].Model_.m_pMaterials
	lea	ecx,[rcx+rdi].Material.m_specular
	invoke	memcpy;memcpy(m_pMaterials[i].m_specular,pMaterial->m_specular,sizeof(float)*4 );
	mov	r8d,(sizeof float)*4
	mov	ecx,pMaterial
	lea	edx,[rcx].MS3DMaterial.m_emissive
	mov	rcx,[rsi].Model_.m_pMaterials
	lea	ecx,[rcx+rdi].Material.m_emissive
	invoke	memcpy;memcpy(m_pMaterials[i].m_emissive,pMaterial->m_emissive,sizeof(float)*4 );
	mov	ecx,pMaterial
	mov	edx,[rcx].MS3DMaterial.m_shininess
	mov	rcx,[rsi].Model_.m_pMaterials
	mov	[rcx+rdi].Material.m_shininess,edx;m_pMaterials[i].m_shininess = pMaterial->m_shininess
	mov	ecx,pMaterial
	lea	ecx,[rcx].MS3DMaterial.m_texture
	invoke	strlen
	lea	r8d,[rax+1]
	invoke	RtlAllocateHeap,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY
	mov	rcx,[rsi].Model_.m_pMaterials
	mov	[rcx+rdi].Material.m_pTextureFilename,eax;m_pMaterials[i].m_pTextureFilename = new char[strlen( pMaterial->m_texture )+1];
	mov	ecx,pMaterial
	lea	edx,[rcx].MS3DMaterial.m_texture
	mov	rcx,[rsi].Model_.m_pMaterials
	mov	ecx,[rcx+rdi].Material.m_pTextureFilename
	invoke	strcpy;strcpy( m_pMaterials[i].m_pTextureFilename, pMaterial->m_texture );
	add	pPtr,sizeof MS3DMaterial;pPtr += sizeof( MS3DMaterial );
	add	edi,sizeof Material
	cmp	edi,temp;nMaterials*(sizeof Material)
	jb	@b
; reloadTextures          OpenGL
	mov	ecx,esi;MilkshapeModel
	invoke	reloadTextures
;   ,       
;  
exit0:	invoke	HeapFree,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,pBuffer
	mov	esi,old_esi
	mov	edi,old_edi
	leave
	ret
loadModelData endp
reloadTextures proc MilkshapeModel:dword
local	old_edi:dword
local	old_esi:dword
local	temp:dword

	mov	old_edi,edi
	mov	old_esi,esi
	mov	esi,ecx;esi=MilkshapeModel
	imul	eax,[rsi].Model_.m_numMaterials,sizeof Material
	mov	temp,eax
	xor	edi,edi
; ---------------------------------------------------------------------------
@0:	mov	rcx,[rsi].Model_.m_pMaterials;+10h]
	mov	ecx,[rcx+rdi].Material.m_pTextureFilename;+48h
	cmp	byte ptr [rcx],0
	je	@f
	mov	rcx,[rsi].Model_.m_pMaterials;+10h
	mov	ecx,[rcx+rdi].Material.m_pTextureFilename;+48h
	call	LoadGLTexture
@@:	mov	rcx,[rsi].Model_.m_pMaterials;+10h]
	mov	[rcx+rdi].Material.m_texture,eax;+44h], eax
	add	edi,sizeof Material
	cmp	edi,temp;eax,[rdx].Model_.m_numMaterials;+0Ch
	jb	@0
	mov	edi,old_edi
	mov	esi,old_esi
	leave
	ret
reloadTextures endp
LoadGLTexture proc Filename:dword; Load Bitmaps And Convert To Textures
local	texture:dword
local	hFile:dword
local	FSize:dword
local	old_edi:dword
local	pImage:TEXTURE_IMAGE
local	szReadWrite:dword	;number of bytes actually read or write
local	Mem:qword
local	buff[20]:dword

	mov	old_edi,edi
	xor	r8d,r8d
	mov	[rsp+30h],r8
	mov	qword ptr [rsp+28h],FILE_ATTRIBUTE_ARCHIVE
	mov	qword ptr [rsp+20h],OPEN_EXISTING
	invoke	CreateFile,,GENERIC_READ or GENERIC_WRITE,,0
	mov	hFile,eax
        invoke	GetFileSize,eax,0
        mov	FSize,eax
	invoke	RtlAllocateHeap,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax
	mov	Mem,rax
	mov	edi,eax
	and	qword ptr [rsp+20h],0
	lea	r9d,szReadWrite
        invoke	ReadFile,hFile,eax,FSize
        invoke	CloseHandle,hFile
	mov	eax,edi
        add	eax,[rdi + BITMAPFILEHEADER.bfOffBits]
	mov	pImage.data_,eax; Create Storage Space For The Texture
        lea	edi,[rdi + sizeof BITMAPFILEHEADER]
	mov	eax,[rdi + BITMAPINFOHEADER.biWidth]
        mov	pImage.sizeX,eax
        movzx	eax, word ptr [rdi + BITMAPINFOHEADER.biHeight]
        mov	pImage.sizeY,eax
;	pImage = LoadBMP( filename ); Loads The Bitmap Specified By filename

; Load The Bitmap, Check For Errors, If Bitmap's Not Found Quit
;	if ( pImage != NULL && pImage->data != NULL ); If Texture Image Exists
	lea	edx,texture
	invoke	glGenTextures,1; Create The Texture
; Typical Texture Generation Using Data From The Bitmap
	invoke	glBindTexture,GL_TEXTURE_2D,texture;
        mov	r9d,pImage.sizeX
        mov	eax,pImage.sizeX
	mov	[rsp+20h],rax
	xor	edx,edx
	mov	[rsp+28h],rdx
	mov	qword ptr [rsp+30h],GL_BGR
	mov	qword ptr [rsp+38h],GL_UNSIGNED_BYTE
	mov	eax,pImage.data_
	mov	[rsp+40h],rax
	invoke	glTexImage2D,GL_TEXTURE_2D,,3
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR;
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR;
	invoke	HeapFree,hHeap,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,Mem; Free The Image Structure
	mov	eax,texture;	return texture; Return The Status

	mov	edi,old_edi
	leave
	ret
LoadGLTexture endp

draw proc Model0:dword
local	texEnabled:byte
local	materialIndex:dword
local	j:dword
local	triangleIndex:dword
local	pTri:qword
local	k:dword
local	index:dword
local	temp:dword
local	old_edi:dword
local	old_esi:dword
local	buff[20]:dword

	mov	old_edi,edi
	mov	old_esi,esi
	mov	esi,ecx

	invoke	glIsEnabled, GL_TEXTURE_2D
	mov	texEnabled, al

	imul	eax,[rsi].Model_.m_numMeshes,sizeof Mesh
	mov	temp,eax

	xor	edi,edi;and	i, 0
; ---------------------------------------------------------------------------
@1:	mov	rax, [rsi].Model_.m_pMeshes
	mov	edx, [rax+rdi].Mesh.m_materialIndex
	mov	materialIndex,edx;materialIndex = m_pMeshes[i].m_materialIndex
	or	edx,edx
	js	@3
	mov	rax,[rsi].Model_.m_pMaterials
	imul	edx,materialIndex, sizeof Material
	add	eax,edx
	lea	r8d,[rax+rdx].Material.m_ambient;m_pMaterials[materialIndex].m_ambient
	invoke	glMaterialfv, GL_FRONT, GL_AMBIENT
        mov	rax,[rsi].Model_.m_pMaterials
	imul	edx,materialIndex, sizeof Material
        lea	r8d,[rax+rdx].Material.m_diffuse;m_pMaterials[materialIndex].m_diffuse
	invoke	glMaterialfv, GL_FRONT, GL_DIFFUSE
        mov	rax,[rsi].Model_.m_pMaterials
	imul	edx,materialIndex, sizeof Material
        lea	r8d,[rax+rdx].Material.m_specular;m_pMaterials[materialIndex].m_specular
	invoke	glMaterialfv, GL_FRONT, GL_SPECULAR
        mov	rax,[rsi].Model_.m_pMaterials
	imul	edx,materialIndex, sizeof Material
        lea	r8d,[rax+rdx].Material.m_emissive;m_pMaterials[materialIndex].m_emissive
	invoke	glMaterialfv, GL_FRONT, GL_EMISSION
	imul	ecx,materialIndex, sizeof Material
        mov	rdx,[rsi].Model_.m_pMaterials
	movss	xmm2,dword ptr [rdx+rcx].Material.m_shininess;_pMaterials[materialIndex].m_shininess
	invoke	glMaterialf, GL_FRONT, GL_SHININESS
	imul	edx, materialIndex, sizeof Material
        mov	rax, [esi].Model_.m_pMaterials
	cmp	dword ptr [rax+rdx].Material.m_texture, 0;m_pMaterials[materialIndex].m_texture
	jle	@2
	imul	edx, materialIndex, sizeof Material
        mov	rax, [esi].Model_.m_pMaterials
	mov	edx, [rax+rdx].Material.m_texture;m_pMaterials[materialIndex].m_texture
	invoke	glBindTexture, GL_TEXTURE_2D
	invoke	glEnable, GL_TEXTURE_2D
	jmp	@4
; ---------------------------------------------------------------------------
@2:	invoke	glDisable, GL_TEXTURE_2D
	jmp	@4
@3:	invoke	glDisable, GL_TEXTURE_2D
@4:	invoke	glBegin,GL_TRIANGLES
	and	j, 0
; ---------------------------------------------------------------------------
@5:	mov	edx,[rsi].Mesh.m_pTriangleIndices        
	mov	rcx,[rdi+rdx].Model_.m_pMeshes
	mov	eax, j
	mov	edx, [rcx+rax*4]
	mov	triangleIndex,edx ;int triangleIndex = m_pMeshes[i].m_pTriangleIndices[j]
	mov	rax,[rsi].Model_.m_pTriangles;
	imul	edx,triangleIndex,sizeof Triangle

	add	eax,edx;lea	eax,[rdx+rax]
	mov	pTri, rax	;const Triangle* pTri = &m_pTriangles[triangleIndex]
	and	k, 0
; ---------------------------------------------------------------------------
@6:	imul	eax, k,4
	mov	rdx, pTri
	mov	ecx, [rdx+rax].Triangle.m_vertexIndices
	mov	index, ecx	;int index = pTri->m_vertexIndices[k]
	imul	ecx, k,3*4
	add	rcx,pTri;lea	ecx,[rdx+rax].Triangle.m_vertexNormals;pTri->m_vertexNormals[k]
	invoke	glNormal3fv
	mov	edx, k
	mov	rcx, pTri
	movss	xmm1, dword ptr	[rcx+rdx*4].Triangle.m_t ;pTri->m_t[k]
	movss	xmm0, dword ptr	[rcx+rdx*4].Triangle.m_s ;pTri->m_s[k]	
	invoke	glTexCoord2f
	mov	rcx, [rsi].Model_.m_pVertices
	imul	eax, index,sizeof Vertex
	lea	ecx, [rcx+rax].Vertex.m_location ;m_pVertices[index].m_location
	invoke	glVertex3fv
	inc	k
	cmp	k, 3
	jb	@6
; ---------------------------------------------------------------------------
	inc	j
	mov	rax, [rsi].Model_.m_pMeshes
	mov	edx, [rdi+rax].Mesh.m_numTriangles
	cmp	j,edx;m_pMeshes[i].m_numTriangles
	jb	@5
; ---------------------------------------------------------------------------
	invoke	glEnd
	add	edi,sizeof Mesh
	cmp	temp,edi
	ja	@1
; ---------------------------------------------------------------------------
	mov	ecx, GL_TEXTURE_2D
	cmp	texEnabled,0
	jz	@9
	invoke	glEnable
	jmp	@f
; ---------------------------------------------------------------------------
@9:	invoke	glDisable
@@:	mov	edi,old_edi
	mov	esi,old_esi
	leave
	ret
draw endp

;---------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson #31: Model Rendering Tutorial",0
FileName	db "br_Rabbit3.cur",0
FileName2	db "data/model.ms3d",0
Str2		db "MS3D000000",0
Texture1_Id	dd ?
yrot		dd 0
pModel		dq ?;Model_ <>
Mem1	dq ?
Mem2	dq ?
Mem3	dq ?
Mem4	dq ?
Mem5	dq ?
;Mem6	dq ?
;Mem7	dq ?
hHeap	dq ?
;flat--------------------------
const0_003	dd 0.003
const0_01	dd 0.01
const0_1	dd 0.1
const0_5	dd 0.5
const1		dd 1.0
const4		dd 4.0
const10		dd 10.0
const25		dd 25.0
const26		dd 26.0
const30		dd 30.0
const32		dd 32.0
const200	dd 200.0
const_200       dd -200.0
const1000	dd 1000.0
;double----------------------------
;constd0_1	dq 0.1
constd1		dq 1.0
constd45	dq 45.0
constd75	dq 75.0
constd1000	dq 1000.0
end